#pragma once
#include<iostream>
#include<climits>
#include<tuple>
#include<vector>
#include<time.h>
using namespace std;
typedef struct node node;

// Structure representing the nodes of the graph infrastructure
struct node {
    int id = -1;
    int preNex = -1; // Previous node in Dijkstra's representation // Next node in Eppstein's representation: the shortest path to the destination
    int dis = INT_MAX; // Distance to the destination (Dijkstra)
    bool v = false; // Variable to check if a node has been visited (Dijkstra)
    int capaMem = -1; // Memory capacity of the node
    vector<tuple<node*, int>> succ; // Vector of successor nodes in the graph
};

// Structure representing the links in the graph
struct arc {
    int id;
    int wei; // Weight of the arc
};

// Function to initiate the heap list
void initMinHeap(MinHeap* h, treeNode* orig) {
    h->insertKey({ orig->wei, orig->idNodeGraph, {orig->idNodeGraph} });
}

// Structure representing a deployment of an SFC (Service Function Chain)
struct deployment {
    vector<tuple<int, vector<int>>> chain; // Represents a set of tuples indicating the nodes and their successors: Node; Successors
    vector<tuple<int, vector<int>, vector<vector<int>>>> placement; // Represents the placement of micro-services on the nodes: Node; Deployed S; Parallel S
};

// Structure used to store an SFC and a score that can represent the margin of the SFC, for example
struct scoreSFC {
    vector<tuple<int, vector<int>>> SFC;
    int id; 
    int src; 
    int dst; 
    int lat; 
    int score;
};

// Additional structures and code may follow...
